Option Strict Off
Option Explicit On
Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Math
Imports System.Text.RegularExpressions
Imports System.Threading

Public Structure ImageProps
    Public columns() As Byte
    Public rows() As Byte
    Public imageWidth() As Byte
    Public numImages() As Byte
    Public numImageBytes() As Byte
    Public botZeroes() As Byte
    Public topZeroes() As Byte
    Public picPos() As Byte
    Public picWidth() As Byte
    Public firstHeight() As Byte
    Public imageData() As Byte
End Structure


Public Class Converter
    Public sImage As ImageProps
    Public finalWidth As Integer = 0
    Public colfile As String = ""
    Public cimfile As String = ""
    Public bmpfile As String = ""

    Function CIMReader(ByVal filepath As String) As ImageProps
        Dim fsPcx As FileStream
        Dim i As Integer = 0


        fsPcx = File.Open(filepath, FileMode.Open, FileAccess.Read)

        'Store the column info in array
        i = 0
        ReDim CIMReader.columns(3)
        While i < 4
            CIMReader.columns(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the row info in array
        i = 0
        ReDim CIMReader.rows(3)
        While i < 4
            CIMReader.rows(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the image width info in array
        i = 0
        ReDim CIMReader.imageWidth(3)
        While i < 4
            CIMReader.imageWidth(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the number of images in array
        i = 0
        ReDim CIMReader.numImages(3)
        While i < 4
            CIMReader.numImages(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the number of bytes in the image data in array
        i = 0
        ReDim CIMReader.numImageBytes(3)
        While i < 4
            CIMReader.numImageBytes(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the bottom zeroes image data info in array
        i = 0
        ReDim CIMReader.botZeroes(BitConverter.ToInt32(CIMReader.imageWidth, 0) - 1)
        While i < BitConverter.ToInt32(CIMReader.imageWidth, 0)
            CIMReader.botZeroes(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the top zeroes image data info in array
        i = 0
        ReDim CIMReader.topZeroes(BitConverter.ToInt32(CIMReader.imageWidth, 0) - 1)
        While i < BitConverter.ToInt32(CIMReader.imageWidth, 0)
            CIMReader.topZeroes(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the picture positions info in array
        i = 0
        ReDim CIMReader.picPos(4 * BitConverter.ToInt32(CIMReader.numImages, 0) - 1)
        While i < 4 * BitConverter.ToInt32(CIMReader.numImages, 0)
            CIMReader.picPos(i) = fsPcx.ReadByte
            i += 1
        End While

        'Store the picture width info in array
        i = 0
        ReDim CIMReader.picWidth(BitConverter.ToInt32(CIMReader.numImages, 0) - 1)
        While i < BitConverter.ToInt32(CIMReader.numImages, 0)
            CIMReader.picWidth(i) = fsPcx.ReadByte
            i += 1
        End While

        Dim iMod = 0
        If CIMReader.numImageBytes(2) <> 0 Then
            iMod = 4
        Else
            iMod = 2
        End If

        fsPcx.Seek(2 * BitConverter.ToInt32(CIMReader.imageWidth, 0) + _
        10 * BitConverter.ToInt32(CIMReader.numImages, 0) + 20 + iMod, 0)
        'MsgBox(fsPcx.Position)

        'Store the first height image data info in array
        i = 0
        ReDim CIMReader.firstHeight(iMod * BitConverter.ToInt32(CIMReader.imageWidth, 0) - 1)
        While i < iMod * BitConverter.ToInt32(CIMReader.imageWidth, 0)
            CIMReader.firstHeight(i) = fsPcx.ReadByte
            i += 1
        End While

        'MsgBox(fsPcx.Position)

        'Store the image data info in array
        i = 0
        ReDim CIMReader.imageData(BitConverter.ToInt32(CIMReader.numImageBytes, 0) - 1)
        While i < BitConverter.ToInt32(CIMReader.numImageBytes, 0)
            CIMReader.imageData(i) = fsPcx.ReadByte
            i += 1
        End While
        fsPcx.Close()
        fsPcx.Dispose()

        Return CIMReader
    End Function
    Function CreateImage(ByVal filepath As String)
        sImage = CIMReader(filepath)
        Dim imageWidth As Integer = BitConverter.ToInt32(sImage.imageWidth, 0)
        Dim picPos(sImage.picPos.Length / 4 - 1) As Integer
        Dim picWidth(sImage.picWidth.Length - 1) As Integer
        'MsgBox(imageWidth Mod 4)
        Dim imageHeight As Integer = CType(sImage.botZeroes(0), Integer) + CType(sImage.topZeroes(0), Integer) + CType(sImage.firstHeight(0), Integer)
        Dim imageRows As Integer = BitConverter.ToInt32(sImage.rows, 0)

        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim k As Integer = 0
        Dim x As Integer = 0
        Dim y As Integer = 0

        Dim totalbuffer As Integer = 0
        Dim buffer(sImage.picWidth.Length - 1, 2) As Integer
        Dim horPos As Integer = 0
        Dim vertPos As Integer = 0

        While i < sImage.picPos.Length / 4
            picPos(i) = BitConverter.ToInt32(sImage.picPos, i * 4)
            picWidth(i) = CType(sImage.picWidth(i), Integer)
            i += 1
        End While
        If MaxValOfIntArray(picWidth) Mod 32 = 0 Then
            finalWidth = MaxValOfIntArray(picWidth)
        Else
            finalWidth = MaxValOfIntArray(picWidth) + 32 - (MaxValOfIntArray(picWidth) Mod 32)
        End If


        i = 0
        While i < sImage.picWidth.Length
            buffer(i, 0) = finalWidth - CType(sImage.picWidth(i), Integer)
            totalbuffer += buffer(i, 0)
            If buffer(i, 0) Mod 2 Then
                buffer(i, 1) = Truncate(buffer(i, 0) / 2) + 1
                buffer(i, 2) = Truncate(buffer(i, 0) / 2)

            Else
                buffer(i, 1) = buffer(i, 0) / 2
                buffer(i, 2) = buffer(i, 0) / 2
            End If
            i += 1
        End While

        Dim imageData((imageWidth + totalbuffer) / imageRows - 1, imageHeight * imageRows - 1) As Byte

        ' Initialize the array to values of 255
        i = 0
        j = 0
        While j < (imageWidth + totalbuffer) / imageRows
            While i < imageHeight * imageRows
                imageData(j, i) = &HFF
                i += 1
            End While
            j += 1
            i = 0
        End While
        While k < BitConverter.ToInt32(sImage.numImages, 0)

            ' Write the Left Buffer for the image
            i = 0
            j = 0

            While j < buffer(k, 1)
                While i < imageHeight
                    imageData(horPos + j, vertPos + i) = &H0
                    i += 1
                End While
                j += 1
                i = 0
            End While
            horPos += j

            ' Start by writing in all of the top Zeroes
            j = 0
            While j < picWidth(k)
                While i < sImage.topZeroes(y + j) And i < imageHeight
                    imageData(horPos + j, vertPos + i) = 0
                    i += 1
                End While
                j += 1
                i = 0
            End While

            ' Now write in all of the bottom Zeroes
            i = 0
            j = 0
            While j < picWidth(k)
                While i < sImage.botZeroes(y + j) And i < imageHeight
                    imageData(horPos + j, vertPos + imageHeight - 1 - i) = 0
                    i += 1
                End While
                j += 1
                i = 0
            End While
            y += j
            ' Now write in the image data
            i = 0
            j = 0

            While j < picWidth(k)
                While i < imageHeight
                    If imageData(horPos + j, vertPos + i) = &HFF Then
                        Try
                            imageData(horPos + j, vertPos + i) = sImage.imageData(x)
                        Catch ex As Exception
                            Exit While
                        End Try

                        x += 1
                    End If

                    i += 1
                End While
                j += 1
                i = 0
            End While
            horPos += j

            i = 0
            j = 0
            While j < buffer(k, 2)
                While i < imageHeight
                    imageData(horPos + j, vertPos + i) = &H0
                    i += 1
                End While
                j += 1
                i = 0
            End While
            horPos += j

            k += 1

            If k Mod BitConverter.ToInt32(sImage.columns, 0) = 0 Then
                horPos = 0
                vertPos += imageHeight
            End If
        End While
        Return imageData

    End Function

    Private Sub WriteBmp(ByVal palette(,) As Byte, ByVal imagedata(,) As Byte, ByVal picwidth As Integer, ByVal picheight As Integer, ByVal intHres As Integer, ByVal intVres As Integer, ByVal writefile As Boolean)

        'Dim picWidth As Integer = finalWidth * BitConverter.ToInt32(sImage.columns, 0)
        Dim pw() As Byte = BitConverter.GetBytes(picWidth)
        'Dim picHeight As Integer = (CType(sImage.botZeroes(0), Integer) + CType(sImage.topZeroes(0), Integer) + CType(sImage.firstHeight(0), Integer)) * BitConverter.ToInt32(sImage.rows, 0)
        Dim ph() As Byte = BitConverter.GetBytes(picHeight)
        Dim imagesize As Integer = imagedata.Length
        Dim isz() As Byte = BitConverter.GetBytes(imagesize)
        Dim filesize As Integer = imagedata.Length + 1078
        Dim fsz() As Byte = BitConverter.GetBytes(filesize)
        Dim hres() As Byte = BitConverter.GetBytes(intHres * 39.37)
        Dim vres() As Byte = BitConverter.GetBytes(intVres * 39.37)

        Dim bHeader() As Byte = {&H42, &H4D, fsz(0), fsz(1), fsz(2), fsz(3), 0, 0, 0, 0, _
                    &H36, &H4, 0, 0, &H28, 0, 0, 0, pw(0), pw(1), pw(2), pw(3), ph(0), ph(1), ph(2), _
                    ph(3), 1, 0, 8, 0, 0, 0, 0, 0, isz(0), isz(1), isz(2), isz(3), hres(0), hres(1), _
                    hres(2), hres(3), vres(0), vres(1), vres(2), vres(3), 0, 1, 0, 0, 0, 1, 0, 0}
        Dim msBmp As New MemoryStream

        If cbTrans.CheckState = CheckState.Checked Then
            palette(0, 0) = 1
            palette(0, 1) = 1
            palette(0, 2) = 1
        End If

        Dim x As Integer = 0

        '<--------------------------------------------------------------
        'Write the header.
        '-------------------------------------------------------------->
        While x < bHeader.Length
            msBmp.WriteByte(bHeader(x))
            x = x + 1
        End While

        '<--------------------------------------------------------------
        'Write the palette.
        '-------------------------------------------------------------->
        x = 0

        While x < 256
            msBmp.WriteByte(palette(x, 2))
            msBmp.WriteByte(palette(x, 1))
            msBmp.WriteByte(palette(x, 0))
            msBmp.WriteByte(0)
            x = x + 1
        End While

        '<--------------------------------------------------------------
        'Write the raw image.
        '-------------------------------------------------------------->
        Dim xMin As Integer = 0
        Dim xMax As Integer = picWidth
        Dim yMin As Integer = 0
        Dim yMax As Integer = picHeight - 1
        x = 0
        Dim y As Integer = yMax

        While y >= yMin
            While x < xMax
                msBmp.WriteByte(imagedata(x, y))
                x = x + 1
            End While
            While x < picWidth
                msBmp.WriteByte(0)
                x = x + 1
            End While
            y = y - 1
            x = xMin
        End While

        Dim bmpImage As Bitmap = Image.FromStream(msBmp)
        'PictureBox1.Image = Image.FromStream(msBmp)

        If writefile Then
            Dim fsBmp As New FileStream(bmpfile, FileMode.Create, FileAccess.Write)
            msBmp.WriteTo(fsBmp)
            fsBmp.Close()
            fsBmp.Dispose()
        End If
        If cbTrans.CheckState = CheckState.Checked Then
            bmpImage.MakeTransparent(Color.FromArgb(1, 1, 1))
            If writefile Then
                bmpImage.Save(bmpfile, ImageFormat.Png)
                'Transparency.MakeTransparent(Image.FromStream(msBmp), Color.FromArgb(1, 1, 1)).Save(bmpfile, ImageFormat.Gif)
            End If
            PictureBox1.Image = bmpImage
        Else
            If writefile Then
                bmpImage.Save(bmpfile, ImageFormat.Png)
                'Transparency.MakeTransparent(Image.FromStream(msBmp), Color.Empty).Save(bmpfile, ImageFormat.Gif)
            End If
            PictureBox1.Image = bmpImage
        End If

        msBmp.Flush()
        msBmp.Dispose()
    End Sub

    Private Sub butCreate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butCreate.Click

        myCreate()

    End Sub

    Private Sub myCreate()
        If cimfile.Substring(cimfile.Length - 3).ToLower = "cim" Then
            Dim rawImage(,) As Byte = CreateImage(cimfile)
            Dim palette(,) As Byte = ColProcessor.Reader(colfile, udLum.Value)
            Dim picWidth As Integer = finalWidth * BitConverter.ToInt32(sImage.columns, 0)
            Dim picHeight As Integer = (CType(sImage.botZeroes(0), Integer) + CType(sImage.topZeroes(0), Integer) + CType(sImage.firstHeight(0), Integer)) * BitConverter.ToInt32(sImage.rows, 0)
            Call WriteBmp(palette, rawImage, picWidth, picHeight, 72, 72, True)
        ElseIf cimfile.Substring(cimfile.Length - 3).ToLower = "pcx" Then
            Dim structRaw As PcxImage = PcxProcessor.Reader(cimfile)
            If cbDefPal.CheckState = CheckState.Unchecked Then
                Dim palette(,) As Byte = ColProcessor.Reader(colfile, udLum.Value)
                WriteBmp(palette, structRaw.bData, structRaw.intWidth, structRaw.intHeight, structRaw.HDPI, structRaw.VDPI, True)
            Else
                WriteBmp(structRaw.bPalette, structRaw.bData, structRaw.intWidth, structRaw.intHeight, structRaw.HDPI, structRaw.VDPI, True)
            End If
        Else
            MsgBox("Unknown File Format")
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim i As Integer = 0
        Dim fileNames1 As String()
        Dim fileNames2 As String()
        Dim fileNames As String()

        FolderBrowserDialog1.RootFolder = Environment.SpecialFolder.Desktop
        FolderBrowserDialog1.Description = "Select Folder Containing CIM Files."
        If FolderBrowserDialog1.ShowDialog = DialogResult.OK Then
            fileNames1 = System.IO.Directory.GetFiles(FolderBrowserDialog1.SelectedPath, "*.cim")
            fileNames2 = System.IO.Directory.GetFiles(FolderBrowserDialog1.SelectedPath, "*.pcx")
            ReDim fileNames(fileNames1.Length + fileNames2.Length - 1)
            fileNames1.CopyTo(fileNames, 0)
            fileNames2.CopyTo(fileNames, fileNames1.Length)
            Array.Sort(fileNames)
            lbCIM.Items.Clear()
            cimfile = ""
            i = 0
            If fileNames.Length > 0 Then
                While i < fileNames.Length
                    lbCIM.Items.Add(System.IO.Path.GetFileName(fileNames(i)))
                    i = i + 1
                End While
                tbCIM.Text = FolderBrowserDialog1.SelectedPath
                checkfiles()
            End If

        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim i As Integer = 0
        Dim fileNames As String()

        FolderBrowserDialog1.RootFolder = Environment.SpecialFolder.Desktop
        FolderBrowserDialog1.Description = "Select Folder Containing COL Files."
        If FolderBrowserDialog1.ShowDialog = DialogResult.OK Then
            fileNames = System.IO.Directory.GetFiles(FolderBrowserDialog1.SelectedPath, "*.col")
            lbCOL.Items.Clear()
            colfile = ""
            i = 0
            If fileNames.Length > 0 Then
                While i < fileNames.Length
                    lbCOL.Items.Add(System.IO.Path.GetFileName(fileNames(i)))
                    i = i + 1
                End While
                tbCOL.Text = FolderBrowserDialog1.SelectedPath
                checkfiles()
            End If
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        FolderBrowserDialog1.RootFolder = Environment.SpecialFolder.Desktop
        FolderBrowserDialog1.Description = "Select Folder to Save BMP Files."
        If FolderBrowserDialog1.ShowDialog = DialogResult.OK Then
            tbBMP.Text = FolderBrowserDialog1.SelectedPath
            checkfiles()
        End If

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Me.Close()
    End Sub
    Function MaxValOfIntArray(ByRef TheArray As Object) As Integer
        'This function gives max value of int array without sorting an array
        Dim i As Integer
        Dim MaxIntegersIndex As Integer
        MaxIntegersIndex = 0

        For i = 1 To UBound(TheArray)
            If TheArray(i) > TheArray(MaxIntegersIndex) Then
                MaxIntegersIndex = i
            End If
        Next
        'index of max value is MaxValOfIntArray
        MaxValOfIntArray = TheArray(MaxIntegersIndex)
    End Function

    Private Sub lbCIM_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbCIM.SelectedIndexChanged
        cimfile = tbCIM.Text & "\" & lbCIM.SelectedItem

        If cimfile.Substring(cimfile.Length - 3).ToLower = "pcx" Then
            cbDefPal.Enabled = True
        Else
            cbDefPal.Enabled = False
            cbDefPal.CheckState = False
        End If
        checkfiles()
    End Sub

    Private Sub lbCOL_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbCOL.SelectedIndexChanged
        colfile = tbCOL.Text & "\" & lbCOL.SelectedItem
        If cbDefPal.CheckState = CheckState.Unchecked Then
            udLum.Enabled = True
            lbLum.Enabled = True
            udLum.Maximum = FileLen(colfile) / 512 - 1
        Else
            udLum.Enabled = False
            lbLum.Enabled = False
        End If
        checkfiles()
    End Sub
    Private Sub checkfiles()
        If colfile <> "" And cimfile <> "" And tbBMP.Text <> "" Then
            butCreate.Enabled = True
            butPreview.Enabled = True
            bmpfile = tbBMP.Text & "\" & System.IO.Path.GetFileNameWithoutExtension(cimfile) & ".png"
        ElseIf cimfile <> "" And tbBMP.Text <> "" And cbDefPal.CheckState = CheckState.Checked Then
            If cimfile.Substring(cimfile.Length - 3).ToLower = "pcx" Then
                butCreate.Enabled = True
                butPreview.Enabled = True
                bmpfile = tbBMP.Text & "\" & System.IO.Path.GetFileNameWithoutExtension(cimfile) & ".png"
            Else
                butCreate.Enabled = False
                butPreview.Enabled = False
            End If
        ElseIf cimfile <> "" And cbDefPal.CheckState = CheckState.Checked Then
            If cimfile.Substring(cimfile.Length - 3).ToLower = "pcx" Then
                butPreview.Enabled = True
            Else
                butPreview.Enabled = False
            End If
        ElseIf colfile <> "" And cimfile <> "" Then
            butPreview.Enabled = True
        Else
            butCreate.Enabled = False
            butPreview.Enabled = False
        End If
        If cbDefPal.Enabled = True And colfile <> "" Then
            If cbDefPal.CheckState = CheckState.Checked Then
                udLum.Enabled = False
                lbLum.Enabled = False
            Else
                udLum.Enabled = True
                lbLum.Enabled = True
            End If
        ElseIf cbDefPal.Enabled = False And colfile <> "" Then
            udLum.Enabled = True
            lbLum.Enabled = True
        End If
    End Sub

    Private Sub butPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butPreview.Click
        myPreview()
    End Sub

    Private Sub myPreview()

        If cimfile.Substring(cimfile.Length - 3).ToLower = "cim" Then
            Dim rawImage(,) As Byte = CreateImage(cimfile)
            Dim palette(,) As Byte = ColProcessor.Reader(colfile, udLum.Value)
            Dim picWidth As Integer = finalWidth * BitConverter.ToInt32(sImage.columns, 0)
            Dim picHeight As Integer = (CType(sImage.botZeroes(0), Integer) + CType(sImage.topZeroes(0), Integer) + CType(sImage.firstHeight(0), Integer)) * BitConverter.ToInt32(sImage.rows, 0)
            Call WriteBmp(palette, rawImage, picWidth, picHeight, 72, 72, False)
        ElseIf cimfile.Substring(cimfile.Length - 3).ToLower = "pcx" Then
            Dim structRaw As PcxImage = PcxProcessor.Reader(cimfile)
            If cbDefPal.CheckState = CheckState.Unchecked Then
                Dim palette(,) As Byte = ColProcessor.Reader(colfile, udLum.Value)
                WriteBmp(palette, structRaw.bData, structRaw.intWidth, structRaw.intHeight, structRaw.HDPI, structRaw.VDPI, False)
            Else
                WriteBmp(structRaw.bPalette, structRaw.bData, structRaw.intWidth, structRaw.intHeight, structRaw.HDPI, structRaw.VDPI, False)
            End If

        Else
            MsgBox("Unknown File Format")
        End If

    End Sub

    Private Sub cbDefPal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDefPal.CheckedChanged
        checkfiles()
    End Sub

    Private Sub Converter_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub btnBatch_Click(sender As System.Object, e As System.EventArgs) Handles btnBatch.Click
        'FormBatch.ShowDialog()

        lbCIM.ScrollAlwaysVisible = True

        For i As Integer = 0 To lbCIM.Items.Count - 1
            lbCIM.SelectedIndex = i
            myPreview()
            myCreate()
        Next
    End Sub
End Class
Public Class Transparency
    Public Shared Function MakeTransparent(ByVal oldbmp As Bitmap, ByVal transparentcolor As Color) As Bitmap
        Dim bmp As New Bitmap(oldbmp.Width, oldbmp.Height, PixelFormat.Format8bppIndexed)
        Dim palette As ColorPalette = bmp.Palette
        Dim nextindex As Byte = 0
        Dim bmpdata As BitmapData = bmp.LockBits(New Rectangle(0, 0, oldbmp.Width, oldbmp.Height), ImageLockMode.WriteOnly, PixelFormat.Format8bppIndexed)
        Dim index As Integer
        For i As Integer = 0 To 255
            palette.Entries(i) = Color.Empty
        Next
        For y As Integer = 0 To oldbmp.Height - 1
            For x As Integer = 0 To oldbmp.Width - 1
                'Get the palette index of the current pixel
                index = Transparency.InPalette(palette, nextindex - 1, oldbmp.GetPixel(x, y))
                'If the color is not in the palette, add it at the next unused index
                If index = -1 Then
                    palette.Entries(nextindex) = oldbmp.GetPixel(x, y)
                    index = nextindex
                    nextindex += CByte(1)
                End If
                'Set the pixel to the proper index
                System.Runtime.InteropServices.Marshal.WriteByte(bmpdata.Scan0, y * bmpdata.Stride + x, CByte(index))
            Next
        Next
        bmp.UnlockBits(bmpdata)
        'If the specified transparent color is included in the palette, change that color to transparent
        If transparentcolor <> Color.Empty AndAlso Transparency.InPalette(palette, nextindex - CByte(1), transparentcolor) <> -1 Then palette.Entries(Transparency.InPalette(palette, nextindex - CByte(1), transparentcolor)) = Color.FromArgb(0, 0, 0, 0)
        bmp.Palette = palette
        Return bmp
    End Function

    'Returns number of colors in bitmap
    Public Shared Function ColorCount(ByVal bmp As Bitmap) As Integer
        Dim palette As New Collections.ObjectModel.Collection(Of Integer)
        Dim currcolor As Integer
        For y As Integer = 0 To bmp.Height - 1
            For x As Integer = 0 To bmp.Width - 1
                currcolor = bmp.GetPixel(x, y).ToArgb()
                If Not palette.Contains(currcolor) Then palette.Add(currcolor)
            Next
        Next
        Return palette.Count
    End Function

    'Returns index of color in palette or -1
    Private Shared Function InPalette(ByVal palette As ColorPalette, ByVal maxindex As Integer, ByVal colortofind As Color) As Integer
        For i As Integer = 0 To maxindex
            If palette.Entries(i).ToArgb() = colortofind.ToArgb() Then Return CInt(i)
        Next
        Return -1
    End Function
End Class