Imports System.IO
Public Structure PcxImage
    Public intPlanes As Integer
    Public intBitDepth As Integer
    Public intWidth As Integer
    Public intHeight As Integer
    Public HDPI As Integer
    Public VDPI As Integer
    Public bData(,) As Byte
    Public bPalette(,) As Byte
End Structure

Public Class PcxProcessor
    Shared Function Reader(ByVal filepath As String)
        Dim structPCX As PcxImage
        Dim xMin As Integer = 0
        Dim yMin As Integer = 0
        Dim xMax As Integer = 0
        Dim yMax As Integer = 0
        Dim intPosition(7) As Integer
        Dim fsPcx As FileStream


        fsPcx = File.Open(filepath, FileMode.Open, FileAccess.Read)

        Dim b As Integer = 0     ' Read the byte and store in dummy variable 
        Dim i As Integer = 0                    ' Initialize counter variable. 0,1,2 correspond to R,G,B in bColors.
        Dim j As Integer = 0                    ' Initialize counter variable.  Corresponds to 0-255 of color palette.
        Dim x As Integer = 0
        Dim iRepeat As Integer = 0
        ' Open the pcx file


        fsPcx.Seek(3, SeekOrigin.Begin)             ' Check Header for bit depth
        structPCX.intBitDepth = fsPcx.ReadByte

        While i < 8
            intPosition(i) = fsPcx.ReadByte
            i = i + 1
        End While

        structPCX.intWidth = intPosition(4) + 256 * intPosition(5) _
        - intPosition(0) - intPosition(1) * 256 + 1

        structPCX.intHeight = intPosition(6) + 256 * intPosition(7) _
        - intPosition(1) - intPosition(2) * 256 + 1

        Dim bHDPI As Byte() = New Byte() {fsPcx.ReadByte, fsPcx.ReadByte}
        Dim bVDPI As Byte() = New Byte() {fsPcx.ReadByte, fsPcx.ReadByte}
        structPCX.HDPI = BitConverter.ToInt16(bHDPI, 0)
        structPCX.VDPI = BitConverter.ToInt16(bVDPI, 0)


        ReDim structPCX.bData(structPCX.intWidth - 1, structPCX.intHeight - 1)

        fsPcx.Seek(65, SeekOrigin.Begin)            ' Check Header for bit planes
        structPCX.intPlanes = fsPcx.ReadByte

        If structPCX.intPlanes = 1 And structPCX.intBitDepth = 8 Then   ' 256 color indexed pcx file

            fsPcx.Seek(128, SeekOrigin.Begin)

            i = 0
            j = 0

            While i < structPCX.intHeight
                While j < structPCX.intWidth
                    iRepeat = 1
                    b = fsPcx.ReadByte
                    If b > 192 Then
                        iRepeat = b - 192
                        b = fsPcx.ReadByte
                    End If
                    While iRepeat >= 1
                        If j >= structPCX.intWidth Then
                            Exit While
                        End If
                        structPCX.bData(j, i) = b
                        iRepeat = iRepeat - 1
                        j = j + 1
                    End While
                End While
                i = i + 1
                j = 0
            End While

            Dim toolTip1 As New ToolTip()
            i = 0
            j = 0

            '<----------------------------------------------------------------------------------------------------------------
            ' This While loop reads the pcx file byte by byte and stores it in the multi demensional array bColors.  The j
            ' position corresponds to indexed colors 0-255.  The i position corresponds to the RGB triplet, where 0=R, 1=G,
            ' and 2=B.
            '---------------------------------------------------------------------------------------------------------------->
            ReDim structPCX.bPalette(255, 2)
            If fsPcx.ReadByte = 12 Then
                b = fsPcx.ReadByte

                While b <> -1
                    If i > 2 Then
                        i = 0
                        j = j + 1
                    End If
                    structPCX.bPalette(j, i) = b
                    b = fsPcx.ReadByte()
                    i = i + 1
                End While
            End If
            fsPcx.Close()   ' Done with pcx file
            fsPcx.Dispose()
            Return structPCX

        End If
        Return 0
    End Function
End Class
